JUCE: CustomTypeface Class Reference

JUCE

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
CustomTypeface Class Reference
juce_graphics » fonts

A typeface that can be populated with custom glyphs. More...

`#include <juce_CustomTypeface.h>`

Inheritance diagram for CustomTypeface:

## Public Member Functions
| CustomTypeface ()
| Creates a new, empty typeface. More...
| CustomTypeface (InputStream &serialisedTypefaceStream)
| Loads a typeface from a previously saved stream. More...
| ~CustomTypeface () override
| Destructor. More...
void | clear ()
| Resets this typeface, deleting all its glyphs and settings. More...
void | setCharacteristics (const String &fontFamily, float ascent, bool isBold, bool isItalic, juce_wchar defaultCharacter) noexcept
| Sets the vital statistics for the typeface. More...
void | setCharacteristics (const String &fontFamily, const String &fontStyle, float ascent, juce_wchar defaultCharacter) noexcept
| Sets the vital statistics for the typeface. More...
void | addGlyph (juce_wchar character, const Path &path, float width) noexcept
| Adds a glyph to the typeface. More...
void | addKerningPair (juce_wchar char1, juce_wchar char2, float extraAmount) noexcept
| Specifies an extra kerning amount to be used between a pair of characters. More...
void | addGlyphsFromOtherTypeface (Typeface &typefaceToCopy, juce_wchar characterStartIndex, int numCharacters) noexcept
| Adds a range of glyphs from another typeface. More...
bool | writeToStream (OutputStream &outputStream)
| Saves this typeface as a Juce-formatted font file. More...
float | getAscent () const override
| Returns the ascent of the font, as a proportion of its height. More...
float | getDescent () const override
| Returns the descent of the font, as a proportion of its height. More...
float | getHeightToPointsFactor () const override
| Returns the value by which you should multiply a JUCE font-height value to convert it to the equivalent point-size. More...
float | getStringWidth (const String &) override
| Measures the width of a line of text. More...
void | getGlyphPositions (const String &, Array< int > &glyphs, Array< float > &xOffsets) override
| Converts a line of text into its glyph numbers and their positions. More...
bool | getOutlineForGlyph (int glyphNumber, Path &) override
| Returns the outline for a glyph. More...
EdgeTable * | getEdgeTableForGlyph (int glyphNumber, const AffineTransform &, float fontHeight) override
| Returns a new EdgeTable that contains the path for the given glyph, with the specified transform applied. More...
Public Member Functions inherited from Typeface
const String & | getName () const noexcept
| Returns the font family of the typeface. More...
const String & | getStyle () const noexcept
| Returns the font style of the typeface. More...
| ~Typeface () override
| Destructor. More...
virtual bool | isSuitableForFont (const Font &) const
| Returns true if this typeface can be used to render the specified font. More...
virtual bool | isHinted () const
| Returns true if the typeface uses hinting. More...
void | applyVerticalHintingTransform (float fontHeight, Path &path)
| Makes an attempt at performing a good overall distortion that will scale a font of the given size to align vertically with the pixel grid. More...
Public Member Functions inherited from ReferenceCountedObject
void | incReferenceCount () noexcept
| Increments the object's reference count. More...
void | decReferenceCount () noexcept
| Decreases the object's reference count. More...
bool | decReferenceCountWithoutDeleting () noexcept
| Decreases the object's reference count. More...
int | getReferenceCount () const noexcept
| Returns the object's current reference count. More...

## Protected Member Functions
virtual bool | loadGlyphIfPossible (juce_wchar characterNeeded)
| If a subclass overrides this, it can load glyphs into the font on-demand. More...
Protected Member Functions inherited from Typeface
| Typeface (const String &name, const String &style) noexcept
Protected Member Functions inherited from ReferenceCountedObject
| ReferenceCountedObject ()=default
| Creates the reference-counted object (with an initial ref count of zero). More...
| ReferenceCountedObject (const ReferenceCountedObject &) noexcept
| Copying from another object does not affect this one's reference-count. More...
| ReferenceCountedObject (ReferenceCountedObject &&) noexcept
| Copying from another object does not affect this one's reference-count. More...
ReferenceCountedObject & | operator= (const ReferenceCountedObject &) noexcept
| Copying from another object does not affect this one's reference-count. More...
ReferenceCountedObject & | operator= (ReferenceCountedObject &&) noexcept
| Copying from another object does not affect this one's reference-count. More...
virtual | ~ReferenceCountedObject ()
| Destructor. More...
void | resetReferenceCount () noexcept
| Resets the reference count to zero without deleting the object. More...

## Protected Attributes
juce_wchar | defaultCharacter
float | ascent
Protected Attributes inherited from Typeface
String | name
String | style

## Additional Inherited Members
Public Types inherited from Typeface
using | Ptr = ReferenceCountedObjectPtr< Typeface >
| A handy typedef for a pointer to a typeface. More...
Static Public Member Functions inherited from Typeface
static Ptr | createSystemTypefaceFor (const Font &font)
| Creates a new system typeface. More...
static Ptr | createSystemTypefaceFor (const void *fontFileData, size_t fontFileDataSize)
| Attempts to create a font from some raw font file data (e.g. More...
static void | setTypefaceCacheSize (int numFontsToCache)
| Changes the number of fonts that are cached in memory. More...
static void | clearTypefaceCache ()
| Clears any fonts that are currently cached in memory. More...
static void | scanFolderForFonts (const File &folder)
| On some platforms, this allows a specific path to be scanned. More...
Static Protected Member Functions inherited from Typeface
static Ptr | getFallbackTypeface ()

## Detailed Description

A typeface that can be populated with custom glyphs.

You can create a CustomTypeface if you need one that contains your own glyphs, or if you need to load a typeface from a Juce-formatted binary stream.

If you want to create a copy of a native face, you can use addGlyphsFromOtherTypeface() to copy glyphs into this face.

NOTE! For most people this class is almost certainly NOT the right tool to use! If what you want to do is to embed a font into your exe, then your best plan is probably to embed your TTF/OTF font file into your binary using the Projucer, and then call Typeface::createSystemTypefaceFor() to load it from memory.

See also
  Typeface, Font

## Constructor & Destructor Documentation

## ◆ CustomTypeface() [1/2]

CustomTypeface::CustomTypeface | ( |  | ) |

Creates a new, empty typeface.

## ◆ CustomTypeface() [2/2]

CustomTypeface::CustomTypeface | ( | InputStream & | serialisedTypefaceStream | ) |
| explicit

Loads a typeface from a previously saved stream.

The stream must have been created by writeToStream().

NOTE! Since this class was written, support was added for loading real font files from memory, so for most people, using Typeface::createSystemTypefaceFor() to load a real font is more appropriate than using this class to store it in a proprietary format.

See also
  writeToStream

## ◆ ~CustomTypeface()

CustomTypeface::~CustomTypeface | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ clear()

void CustomTypeface::clear | ( |  | ) |

Resets this typeface, deleting all its glyphs and settings.

## ◆ setCharacteristics() [1/2]

void CustomTypeface::setCharacteristics | ( | const String & | fontFamily,
|  | float | ascent,
|  | bool | isBold,
|  | bool | isItalic,
|  | juce_wchar | defaultCharacter
| ) |  |
| noexcept

Sets the vital statistics for the typeface.

Parameters

  fontFamily | the typeface's font family
  ascent | the ascent - this is normalised to a height of 1.0 and this is the value that will be returned by Typeface::getAscent(). The descent is assumed to be (1.0 - ascent)
  isBold | should be true if the typeface is bold
  isItalic | should be true if the typeface is italic
  defaultCharacter | the character to be used as a replacement if there's no glyph available for the character that's being drawn

## ◆ setCharacteristics() [2/2]

void CustomTypeface::setCharacteristics | ( | const String & | fontFamily,
|  | const String & | fontStyle,
|  | float | ascent,
|  | juce_wchar | defaultCharacter
| ) |  |
| noexcept

Sets the vital statistics for the typeface.

Parameters

  fontFamily | the typeface's font family
  fontStyle | the typeface's font style
  ascent | the ascent - this is normalised to a height of 1.0 and this is the value that will be returned by Typeface::getAscent(). The descent is assumed to be (1.0 - ascent)
  defaultCharacter | the character to be used as a replacement if there's no glyph available for the character that's being drawn

## ◆ addGlyph()

void CustomTypeface::addGlyph | ( | juce_wchar | character,
|  | const Path & | path,
|  | float | width
| ) |  |
| noexcept

Adds a glyph to the typeface.

The path that is passed in is normalised so that the font height is 1.0, and its origin is the anchor point of the character on its baseline.

The width is the nominal width of the character, and any extra kerning values that are specified will be added to this width.

## ◆ addKerningPair()

void CustomTypeface::addKerningPair | ( | juce_wchar | char1,
|  | juce_wchar | char2,
|  | float | extraAmount
| ) |  |
| noexcept

Specifies an extra kerning amount to be used between a pair of characters.

The amount will be added to the nominal width of the first character when laying out a string.

## ◆ addGlyphsFromOtherTypeface()

void CustomTypeface::addGlyphsFromOtherTypeface | ( | Typeface & | typefaceToCopy,
|  | juce_wchar | characterStartIndex,
|  | int | numCharacters
| ) |  |
| noexcept

Adds a range of glyphs from another typeface.

This will attempt to pull in the paths and kerning information from another typeface and add it to this one.

## ◆ writeToStream()

bool CustomTypeface::writeToStream | ( | OutputStream & | outputStream | ) |

Saves this typeface as a Juce-formatted font file.

A CustomTypeface can be created to reload the data that is written - see the CustomTypeface constructor.

NOTE! Since this class was written, support was added for loading real font files from memory, so for most people, using Typeface::createSystemTypefaceFor() to load a real font is more appropriate than using this class to store it in a proprietary format.

## ◆ getAscent()

float CustomTypeface::getAscent | ( |  | ) | const
| overridevirtual

Returns the ascent of the font, as a proportion of its height.

The height is considered to always be normalised as 1.0, so this will be a value less that 1.0, indicating the proportion of the font that lies above its baseline.

Implements Typeface.

## ◆ getDescent()

float CustomTypeface::getDescent | ( |  | ) | const
| overridevirtual

Returns the descent of the font, as a proportion of its height.

The height is considered to always be normalised as 1.0, so this will be a value less that 1.0, indicating the proportion of the font that lies below its baseline.

Implements Typeface.

## ◆ getHeightToPointsFactor()

float CustomTypeface::getHeightToPointsFactor | ( |  | ) | const
| overridevirtual

Returns the value by which you should multiply a JUCE font-height value to convert it to the equivalent point-size.

Implements Typeface.

## ◆ getStringWidth()

float CustomTypeface::getStringWidth | ( | const String & | text | ) |
| overridevirtual

Measures the width of a line of text.

The distance returned is based on the font having an normalised height of 1.0. You should never need to call this directly! Use Font::getStringWidth() instead!

Implements Typeface.

## ◆ getGlyphPositions()

void CustomTypeface::getGlyphPositions | ( | const String & | text,
|  | Array< int > & | glyphs,
|  | Array< float > & | xOffsets
| ) |  |
| overridevirtual

Converts a line of text into its glyph numbers and their positions.

The distances returned are based on the font having an normalised height of 1.0. You should never need to call this directly! Use Font::getGlyphPositions() instead!

Implements Typeface.

## ◆ getOutlineForGlyph()

bool CustomTypeface::getOutlineForGlyph | ( | int | glyphNumber,
|  | Path & | path
| ) |  |
| overridevirtual

Returns the outline for a glyph.

The path returned will be normalised to a font height of 1.0.

Implements Typeface.

## ◆ getEdgeTableForGlyph()

EdgeTable * CustomTypeface::getEdgeTableForGlyph | ( | int | glyphNumber,
|  | const AffineTransform & | transform,
|  | float | fontHeight
| ) |  |
| overridevirtual

Returns a new EdgeTable that contains the path for the given glyph, with the specified transform applied.

Reimplemented from Typeface.

## ◆ loadGlyphIfPossible()

virtual bool CustomTypeface::loadGlyphIfPossible | ( | juce_wchar | characterNeeded | ) |
| protectedvirtual

If a subclass overrides this, it can load glyphs into the font on-demand.

When methods such as getGlyphPositions() or getOutlineForGlyph() are asked for a particular character and there's no corresponding glyph, they'll call this method so that a subclass can try to add that glyph, returning true if it manages to do so.

## Member Data Documentation

## ◆ defaultCharacter

juce_wchar CustomTypeface::defaultCharacter
| protected

## ◆ ascent

float CustomTypeface::ascent
| protected

The documentation for this class was generated from the following file:

- juce_CustomTypeface.h